#include <conio.h>
#include "sin.h"
#include "cos.h"

#define CORRECT       54613L
#define NUMPOINTS     200
#define NUMTRIANGLES  400
#define D1POINTS      20
#define D2POINTS      10
#define D1ANGLE       18
#define D2ANGLE       36
#define AMBIENT       0x10

extern "C" long SQRT(long arg);
unsigned char far *buf;

void PutPixel(int, int, int);
void Draw1stTriangle(int, int, int, int, int,
                     int, int, int, int, int, int, int, int, int);
void DrawTriangle(int, int, int, int, int, int,
                  int, int, int, int, int, int, int, int, int);

void SetGraphMode();
void SetTextMode();
void TilePage(char color);
void CopyBuf();
void Vertret();
void SetColor(char, char, char, char);
void SetPalette();
void main();

void Draw1stTriangle(int x1, int x2, int x3, int y1, int y2,
                     int n1_x, int n1_y, int n1_z,
                     int n2_x, int n2_y, int n2_z,
                     int n3_x, int n3_y, int n3_z)
{
  long cx1 = (long)x1 << 16, cx2 = (long)x1 << 16;
  long n_x, n_y, n_z;
  long deltay = y2 - y1;
  long cc1_x, cc1_y, cc1_z, cc2_x, cc2_y, cc2_z;
  long dc1_x, dc1_y, dc1_z, dc2_x, dc2_y, dc2_z;
  long dc_x, dc_y, dc_z, cc_x, cc_y, cc_z;
  long dx2, dx3;
  int i = y1, j, dy = 1, c;

  if (!deltay) return;

  cc1_x = (long)n1_x << 16; cc2_x = cc1_x;
  cc1_y = (long)n1_y << 16; cc2_y = cc1_y;
  cc1_z = (long)n1_z << 16; cc2_z = cc1_z;

  if (deltay < 0)
  {
    dy = -1;
    deltay = -deltay;
  }

  dx2 = (long(x2 - x1) << 16) / deltay;
  dx3 = (long(x3 - x1) << 16) / deltay;
  dc1_x = (long(n2_x - n1_x) << 16) / deltay;
  dc1_y = (long(n2_y - n1_y) << 16) / deltay;
  dc1_z = (long(n2_z - n1_z) << 16) / deltay;
  dc2_x = (long(n3_x - n1_x) << 16) / deltay;
  dc2_y = (long(n3_y - n1_y) << 16) / deltay;
  dc2_z = (long(n3_z - n1_z) << 16) / deltay;

  for (; dy > 0 ? (i <= y2) : (i >= y2); i += dy)
  {
    cc_x = cc1_x;
    cc_y = cc1_y;
    cc_z = cc1_z;
    dc_z = ((cx2 - cx1) >> 16) + 1;
    dc_x = (cc2_x - cc1_x) / dc_z;
    dc_y = (cc2_y - cc1_y) / dc_z;
    dc_z = (cc2_z - cc1_z) / dc_z;

    for (j = int(cx1 >> 16); j <= int(cx2 >> 16); j++)
    {
      if (cc_z > 0)
      {
        n_x = cc_x >> 20;
        n_y = cc_y >> 20;
        n_z = cc_z >> 20;
        c = (cc_z / (n_x * n_x + n_y * n_y + n_z * n_z)) >> 3;
      }
      else c = 0;

      asm  cmp    c,   AMBIENT
      asm  jnb    l2
      asm  mov    c,   AMBIENT
l2:   asm  cmp    c,   7Fh
      asm  jb     l1
      asm  mov    c,   7Fh
l1:   asm  les    di,  buf
      asm  mov    bx,  i
      asm  mov    ax,  bx
      asm  shl    bx,  8
      asm  shl    ax,  6
      asm  add    bx,  ax
      asm  add    bx,  j
      asm  add    di,  bx
      asm  mov    ax,  c
      asm  stosb

      cc_x += dc_x;
      cc_y += dc_y;
      cc_z += dc_z;
    }
    cx1 += dx2;
    cx2 += dx3;
    cc1_x += dc1_x;
    cc1_y += dc1_y;
    cc1_z += dc1_z;
    cc2_x += dc2_x;
    cc2_y += dc2_y;
    cc2_z += dc2_z;
  }
}

void DrawTriangle(int x1, int y1, int x2, int y2, int x3, int y3,
                  int n1_x, int n1_y, int n1_z,
                  int n2_x, int n2_y, int n2_z,
                  int n3_x, int n3_y, int n3_z)
{
  long xx1, xx3, xx4, dx2;
  long cc1_x, cc1_y, cc1_z, cc3_x, cc3_y, cc3_z, cc4_x, cc4_y, cc4_z, dc2_x, dc2_y, dc2_z;
  int dy;

  if (y1 == y2 && y1 == y3) return;
  if (x1 == x2 && x1 == x3) return;

  if (y2 < y1)
  {
    y2 ^= y1; y1 ^= y2; y2 ^= y1;
    x2 ^= x1; x1 ^= x2; x2 ^= x1;
    n2_x ^= n1_x; n1_x ^= n2_x; n2_x ^= n1_x;
    n2_y ^= n1_y; n1_y ^= n2_y; n2_y ^= n1_y;
    n2_z ^= n1_z; n1_z ^= n2_z; n2_z ^= n1_z;
  }

  if (y3 < y1)
  {
    y3 ^= y1; y1 ^= y3; y3 ^= y1;
    x3 ^= x1; x1 ^= x3; x3 ^= x1;
    n3_x ^= n1_x; n1_x ^= n3_x; n3_x ^= n1_x;
    n3_y ^= n1_y; n1_y ^= n3_y; n3_y ^= n1_y;
    n3_z ^= n1_z; n1_z ^= n3_z; n3_z ^= n1_z;
  }

  if (y3 < y2)
  {
    y3 ^= y2; y2 ^= y3; y3 ^= y2;
    x3 ^= x2; x2 ^= x3; x3 ^= x2;
    n3_x ^= n2_x; n2_x ^= n3_x; n3_x ^= n2_x;
    n3_y ^= n2_y; n2_y ^= n3_y; n3_y ^= n2_y;
    n3_z ^= n2_z; n2_z ^= n3_z; n3_z ^= n2_z;
  }

  if (y2 == y3)
  {
    if (x2 > x3)
      Draw1stTriangle(x1, x3, x2, y1, y2,
                      n1_x, n1_y, n1_z, n3_x, n3_y, n3_z, n2_x, n2_y, n2_z);
    else
      Draw1stTriangle(x1, x2, x3, y1, y2,
                      n1_x, n1_y, n1_z, n2_x, n2_y, n2_z, n3_x, n3_y, n3_z);
  }
  else
  {
    dy = y3 - y1;
    if (dy < 0) dy = -dy;
    xx1 = x1;
    cc1_x = n1_x;
    cc1_y = n1_y;
    cc1_z = n1_z;
    xx3 = x3;
    cc3_x = n3_x;
    cc3_y = n3_y;
    cc3_z = n3_z;
    xx1 <<= 16;
    cc1_x <<= 16;
    cc1_y <<= 16;
    cc1_z <<= 16;
    xx3 <<= 16;
    cc3_x <<= 16;
    cc3_y <<= 16;
    cc3_z <<= 16;
    dx2 = (xx3 - xx1) / dy;
    dc2_x = (cc3_x - cc1_x) / dy;
    dc2_y = (cc3_y - cc1_y) / dy;
    dc2_z = (cc3_z - cc1_z) / dy;
    dy = y2 - y1;
    if (dy < 0) dy = -dy;
    xx4 = (dx2 * dy) >> 16;
    cc4_x = (dc2_x * dy) >> 16;
    cc4_y = (dc2_y * dy) >> 16;
    cc4_z = (dc2_z * dy) >> 16;
    xx4 += x1;
    cc4_x += n1_x;
    cc4_y += n1_y;
    cc4_z += n1_z;
    if (xx4 < x2)
    {
      Draw1stTriangle(x1, (int)xx4, x2, y1, y2,
                      n1_x, n1_y, n1_z, (int)cc4_x, (int)cc4_y, (int)cc4_z, n2_x, n2_y, n2_z);
      Draw1stTriangle(x3, (int)xx4, x2, y3, y2,
                      n3_x, n3_y, n3_z, (int)cc4_x, (int)cc4_y, (int)cc4_z, n2_x, n2_y, n2_z);
    }
    else
    {
      Draw1stTriangle(x1, x2, (int)xx4, y1, y2,
                      n1_x, n1_y, n1_z, n2_x, n2_y, n2_z, (int)cc4_x, (int)cc4_y, (int)cc4_z);
      Draw1stTriangle(x3, x2, (int)xx4, y3, y2,
                      n3_x, n3_y, n3_z, n2_x, n2_y, n2_z, (int)cc4_x, (int)cc4_y, (int)cc4_z);
    }
  }
}

class TPoint
{
  public:
    int x, y, z;
    TPoint() {}
    TPoint(long x, long y, long z)
    {
      TPoint::x = x;
      TPoint::y = y;
      TPoint::z = z;
    }
    void CorrectAspect()
    {
      y = (y * CORRECT) >> 16;
    }
};

TPoint RotateX(TPoint, unsigned);
TPoint RotateY(TPoint, unsigned);
TPoint RotateZ(TPoint, unsigned);
inline void Triangle2D(TPoint, TPoint, TPoint,
                       int, int, TPoint, TPoint, TPoint);

TPoint RotateX(TPoint p, unsigned angle)
{
  return TPoint(p.x,
                (p.y * cos_table[angle] - p.z * sin_table[angle]) >> 16,
                (p.y * sin_table[angle] + p.z * cos_table[angle]) >> 16);
}

TPoint RotateY(TPoint p, unsigned angle)
{
  return TPoint((p.x * cos_table[angle] - p.z * sin_table[angle]) >> 16,
                p.y,
                (p.x * sin_table[angle] + p.z * cos_table[angle]) >> 16);
}

TPoint RotateZ(TPoint p, unsigned angle)
{
  return TPoint((p.x * cos_table[angle] - p.y * sin_table[angle]) >> 16,
                (p.x * sin_table[angle] + p.y * cos_table[angle]) >> 16,
                p.z);
}

class TNormal
{
  public:
    long x, y, z;
    TNormal() {}
    TNormal(long x, long y, long z)
    {
      TNormal::x = x;
      TNormal::y = y;
      TNormal::z = z;
    }
    TNormal(TPoint p1, TPoint p2, TPoint p3)
    {
      long register t;
      TNormal n1(p2.x - p1.x, p2.y - p1.y, p2.z - p1.z),
              n2(p3.x - p1.x, p3.y - p1.y, p3.z - p1.z);

      x = n1.y * n2.z - n1.z * n2.y;
      y = n1.z * n2.x - n1.x * n2.z;
      z = n1.x * n2.y - n1.y * n2.x;

      t = (long)SQRT(x * x + y * y + z * z);

      x = (x << 16) / t;
      y = (y << 16) / t;
      z = (z << 16) / t;
    }
    long Z()
    {
      return z;
    }
};

inline void Triangle2D(TPoint p1, TPoint p2, TPoint p3,
                       int x, int y, TPoint n1, TPoint n2, TPoint n3)
{
  DrawTriangle((int)p1.x + x, (int)p1.y + y,
               (int)p2.x + x, (int)p2.y + y,
               (int)p3.x + x, (int)p3.y + y,
               n1.x, n1.y, n1.z, n2.x, n2.y, n2.z, n3.x, n3.y, n3.z);
}

class TTriangle {
    TPoint m1, m2, m3;
    int sum;
    TPoint c1, c2, c3;
    TNormal n;
  public:
    TTriangle(): n(), m1(), m2(), m3() {}
    TTriangle(TPoint p1, TPoint p2, TPoint p3, TPoint cc1, TPoint cc2, TPoint cc3):
              n(p1, p2, p3), m1(p1), m2(p2), m3(p3)
    {
      sum = int(m1.z + m2.z + m3.z);
      c1 = cc1;
      c2 = cc2;
      c3 = cc3;
    }
    int Visible()
    {
      return (n.Z() > 0);
    }
    void Draw(unsigned x, unsigned y)
    {
      Triangle2D(m1, m2, m3, x, y, c1, c2, c3);
    }
    long ZSum()
    {
      return sum;
    }
};

class TTorus {
    TPoint p[NUMPOINTS], p2[NUMPOINTS], n[NUMPOINTS], n2[NUMPOINTS];
    int v[NUMTRIANGLES];
    TTriangle t[NUMTRIANGLES];
    void InsertItem(int, int);
    int s;
  public:
    TTorus(int d1, int d2);
    void Draw(unsigned, unsigned, unsigned, unsigned, unsigned);
};

TTorus::TTorus(int d1, int d2)
{
  for (int i = 0; i < D1POINTS; i++)
  {
    for (int j = 0; j < D2POINTS; j++)
    {
      p[i * D2POINTS + j] = TPoint(RotateY(TPoint(((cos_table[j * D2ANGLE] * (long)d2) >> 16) + d1,
                                                  (sin_table[j * D2ANGLE] * (long)d2) >> 16, 0),
                                           i * D1ANGLE));
      long a = cos_table[j * D2ANGLE];
      long b = sin_table[j * D2ANGLE];

      n[i * D2POINTS + j] = TPoint(RotateY(TPoint(a >> 2, b >> 2, 0), i * D1ANGLE));
    }
  }
}

void TTorus::InsertItem(int index, int item)
{
  for (int i = s; i > index; i--)
    v[i] = v[i - 1];
  v[index] = item;
  s++;
}

void TTorus::Draw(unsigned angle_x, unsigned angle_y,
                  unsigned angle_z, unsigned x, unsigned y)
{
  int i = 0, j, a, b, c;

  for (; i < NUMPOINTS; i++)
  {
    p2[i] = TPoint(RotateX(RotateY(RotateZ(p[i], angle_z), angle_y), angle_x));
    n2[i] = TPoint(RotateX(RotateY(RotateZ(n[i], angle_z), angle_y), angle_x));
    p2[i].CorrectAspect();
  }

  for (i = 0; i < D1POINTS; i++)
  {
    for (j = 0; j < D2POINTS; j++)
    {
      a = i + 1;
      if ((i + 1) == D1POINTS) a = 0;
      a = (a << 1) + (a << 3);
      b = (i << 1) + (i << 3);
      c = j + 1;
      if ((j + 1) == D2POINTS) c = 0;
      t[b + j] = TTriangle(p2[b + j], p2[b + c], p2[a + c], n2[b + j], n2[b + c], n2[a + c]);
      t[b + j + NUMPOINTS] = TTriangle(p2[b + j], p2[a + c], p2[a + j], n2[b + j], n2[a + c], n2[a + j]);
    }
  }

  s = 0;

  for (i = 0; i < NUMTRIANGLES; i++)
  {
    if (t[i].Visible())
    {
      for (j = 0; j < s; j++)
      {
        if (t[i].ZSum() <= t[v[j]].ZSum())
        {
          InsertItem(j, i);
          break;
        }
      }
      if (j == s) InsertItem(s, i);
    }
  }

  for (i = 0; i < s; i++)
    t[v[i]].Draw(x, y);
}

class TFlyer {
    int a_x, a_y, a_z;
    int d_ax, d_ay, d_az;
    TTorus t;
  public:
    TFlyer(unsigned r1, int r2, int d_ax, int d_ay, int d_az):
          t(r1, r2)
    {
      TFlyer::d_ax = d_ax;
      TFlyer::d_ay = d_ay;
      TFlyer::d_az = d_az;
      a_x = a_y = a_z = 0;
    }
    void Move()
    {
      t.Draw(a_x, a_y, a_z, 160, 100);

      a_x += d_ax;
      a_y += d_ay;
      a_z += d_az;

      if (a_x < 0) a_x = 360 + a_x;
      if (a_x > 359) a_x = 0;
      if (a_y < 0) a_y = 360 + a_y;
      if (a_y > 359) a_y = 0;
      if (a_z < 0) a_z = 360 + a_z;
      if (a_z > 359) a_z = 0;
    }
};

void SetGraphMode()
{
  asm  mov    ax,  13h
  asm  int    10h
}

void SetTextMode()
{
  asm  mov    ax,  03h
  asm  int    10h
}

void TilePage(char color)
{
  asm  les    di,  buf
  asm  mov    al,  color
  asm  add    al,  63
  asm  cld
  asm  mov    cx,  64
l:asm  push   cx
  asm  mov    ah,  al
  asm  mov    cx,  480
  asm  rep    stosw
  asm  pop    cx
  asm  dec    al
  asm  loop   l
  asm  xor    ax,  ax
  asm  mov    cx,  1280
  asm  rep    stosw
}

void CopyBuf()
{
  asm  push   ds
  asm  push   0A000h
  asm  pop    es
  asm  xor    di,  di
  asm  lds    si,  buf
  asm  mov    cx,  32000
  asm  rep    movsw
  asm  pop    ds
}

void Vertret()
{
    asm  mov    dx,  03DAh
l1: asm  in     al,  dx
    asm  test   al,  8
    asm  jz     l1
l2: asm  in     al,  dx
    asm  test   al,  8
    asm  jnz    l2
}

void SetColor(char color, char r, char g, char b)
{
  asm  mov    dx,  3C8h
  asm  mov    al,  color
  asm  out    dx,  al
  asm  inc    dx
  asm  mov    al,  r
  asm  out    dx,  al
  asm  mov    al,  g
  asm  out    dx,  al
  asm  mov    al,  b
  asm  out    dx,  al
}

void SetPalette()
{
  for (int i = 0; i < 64; i++)
  {
    SetColor(i, i, 0, 0);
    SetColor(i + 64, 63, i, i);
    SetColor(i + 192, 0, i, 0);
  }
}

void main()
{
  SetGraphMode();
  SetPalette();
  TFlyer f(60, 30, 0, 2, 2);
  buf = new char[64000];
  buf = new char[64000];

  do
  {
    TilePage(0xC0);
    f.Move();
    CopyBuf();
  } while (!kbhit());

  SetTextMode();
  cprintf("Phong shading model - by HackMaster\n");
}
